#include <iostream>
#include <fstream>
#include <vector>
#include "product.h"
#include "sale.h"
#include <string>
using namespace std;

typedef std::vector<Product*> ProductList;
typedef std::vector<Sale*> SaleList;
//------------------------------------------------------------------------------
Product* chooseProduct(ProductList& productList);
void printProductList(ProductList& productList);
void addNewProduct(ProductList& productList);
void productSale(ProductList& productList, SaleList& saleList);
void productInfo(ProductList& productList);
void periodIncome(SaleList& saleList);
void bestProduct(ProductList& productList);
void worstProduct(ProductList& productList);
void fromFile(ProductList&, SaleList&);
//------------------------------------------------------------------------------
//==============================================================================
int main ()
{
    ProductList productList;
    SaleList saleList;
    cout <<"=============================================" << endl
         <<"Sveiki atvyke namudine kepyklele!"             << endl
         
         <<"=============================================" << endl;
    for(;;)
    {    cout << "Noredami ieiti i meniu spauskite ENTER...";
         string kl;
         getline(cin,kl);
         system("cls");
         cout << endl
              << "|-----------------------------------|" << endl        
              << "|KEPYKLELES SUVESTINES MENIU:       |" << endl
              << "|===================================|" << endl
              << "|                                   |" << endl
              << "|1 - Produktu sarasas               |" << endl
              << "|2 - Itraukti produkta              |" << endl
              << "|3 - Itraukti pardavima             |" << endl
              << "|4 - Produkto informacija           |" << endl
              << "|5 - Pelningiausias produktas       |" << endl
              << "|6 - Maziausiai uzdirbes produktas  |" << endl
              << "|7 - Laikotarpio apyvarta           |" << endl
              << "|8 - Duomenu ivedimas is failo      |" << endl
              << "|                                   |" << endl
              << "|0 - Baigti darba                   |" << endl
              << "|-----------------------------------|" << endl
              << endl
              << "Jusu pasirinkimas:> ";
         string key;
         cin >> key;
              if (key == "0") return 0;
         else if (key == "1") printProductList(productList);
         else if (key == "2") addNewProduct(productList);
         else if (key == "3") productSale(productList, saleList);
         else if (key == "4") productInfo(productList);
         else if (key == "5") bestProduct(productList);
         else if (key == "6") worstProduct(productList);
         else if (key == "7") periodIncome(saleList);
         else if (key == "8") fromFile(productList, saleList);
         else cout << endl << "Neteisinga komanda..." << endl;
    }
}
//==============================================================================
//------------------------------------------------------------------------------
Product* chooseProduct(ProductList& productList)
{
    for (;;)
    {
       string name;
       printProductList(productList);
       cout << endl
       << "----------------------------------" << endl
       << "Pasirinkite preke ('$'-baigti):> ";
       cin >> name;
       if (name == "$") return 0;
       ProductList::iterator iter = productList.begin();
       for (; iter != productList.end(); iter++)
           if (name == (*iter)->getName()) return *iter;
    }
    return 0;
}
//------------------------------------------------------------------------------
void printProductList(ProductList& productList)
{
     cout << endl
          << "|-------- Prekiu sarasas --------|" << endl;
     ProductList::iterator iter = productList.begin();
     for (; iter != productList.end(); iter++)
         (*iter)->print();
     cout << "|--------------------------------|" << endl;
     string kl;
     getline(cin,kl);
}
//------------------------------------------------------------------------------    
void addNewProduct(ProductList& productList)
{
     string name;
     cout <<"Iveskite prekes pavadinima:";      cin >> name;
     productList.push_back(new Product(name));
     string kl;
     getline(cin, kl);
}
//------------------------------------------------------------------------------ 
void productSale(ProductList& productList, SaleList& saleList){
     cout << "--Prekiu pardavimai--" << endl;
     Product* product = chooseProduct(productList);
     if (product == 0) return;
     string data;
     int    howmuch;
     double cost;
     product->print();
     cout << "Pardavimo data (yyyy.mm.dd): ";  cin >> data;
     cout << "Pardavimu skaicius: ";           cin >> howmuch;
     cout << "Vieneto kaina: ";                cin >> cost;
     
     Sale* sale = new Sale(product, data, howmuch, cost*howmuch);
     product->addSale(sale);
     saleList.push_back(sale);
}
//------------------------------------------------------------------------------
void productInfo(ProductList& productList)
{
     cout << "--Prekiu pardavimo informacija--" << endl;
     Product* product = chooseProduct(productList);
     if (product == 0) return;
     cout << "Prekes informacija:" << endl;
     product->print();
     for (int i = 0; i < product->getSaleNumber(); i++)
         product->getSale(i)->print();    
     string kl;
     getline(cin, kl);    
}
//------------------------------------------------------------------------------
void periodIncome(SaleList& saleList){
     string dataFrom, dataUntil;
     cout << "--Laikotarpio kepykleles apyvarta--" << endl;
     cout << "nuo kada (yyyy.mm.dd): "; cin >> dataFrom;
     cout << "iki kada (yyyy.mm.dd): "; cin >> dataUntil;
     cout << endl;
     double income;
     SaleList::iterator iter = saleList.begin();
     for (; iter != saleList.end(); iter++)
         if (dataFrom <= (*iter)->getData() && (*iter)->getData() <= dataUntil)
         {
           (*iter)->print();
           income += (*iter)->getIncome();
         }
     cout << endl
     << "Bendra laikotarpio apyvarta: " << income 
     << "Lt" << endl;
     string kl;
     getline(cin, kl);
}
//------------------------------------------------------------------------------
void bestProduct(ProductList& productList)
{
     double max = 0;
     Product* temp;
     cout << "-- Pelningiausia preke --" << endl;
     ProductList::iterator iter = productList.begin();
     for (; iter != productList.end(); iter++)
         if (max < (*iter)->productIncome())
         {
           max      = (*iter)->productIncome();
           temp = (*iter);
         }                     
     temp->print();
     string kl;
     getline(cin,kl);
}
//------------------------------------------------------------------------------
void worstProduct(ProductList& productList)
{
     double min = 20000;
     Product* temp;
     cout << "-- Maziausia uzdirbusi preke --" << endl;
     ProductList::iterator iter = productList.begin();
     for (; iter != productList.end(); iter++)
         if (min > (*iter)->productIncome())
         {
           min   = (*iter)->productIncome();
           temp = (*iter);   
         }
     temp->print();
     string kl;
     getline(cin,kl);
}
void fromFile(ProductList& productList, SaleList& saleList){
     ifstream file ("duom.txt");
     string name, data;
     Product* product;
     int         howMuch, number;
     double      cost;
     while (file.good())
     {    
       getline (file, name, '/'); 
       if (!file.good()) break;
       productList.push_back(new Product(name));
           file >> number;
           file.ignore();
           for (int i = 0; i < number; i++)
           {
                file >> data;
                file >> howMuch;
                file >> cost;
                cost*=howMuch;
                ProductList::iterator iter = productList.begin();
                for (; iter != productList.end(); iter++)
                    if (name == (*iter)->getName()) product = *iter;
                    Sale* sale = new Sale(product, data, howMuch, cost);
                    product->addSale(sale);
                    saleList.push_back(sale);
                    file.ignore();
           }
             file.ignore();
     }
     file.close();
     cout << "Duomenys ivesti" << endl;
     string kl;
     getline(cin, kl);
}
